Subject: bug#65455: 30.0.50; Disassemble: error with "free-standing" native compiled function

From: Andrea Corallo <[email-masked]>
Date: Fri, 25 Aug 2023 10:11:58 -0400

Eli Zaretskii <[email-masked]> writes:

>> From: Andrea Corallo <[email-masked]>
>> Cc: [email-masked],  [email-masked]
>> Date: Fri, 25 Aug 2023 07:52:06 -0400
>> 
>> Eli Zaretskii <[email-masked]> writes:
>> 
>> >> > None of the above sounds a good idea to me.  How about a special
>> >> > disassemble-native function, which will keep the temporary file until
>> >> > after the disassembly, and then delete it?  Gerd, would that be good
>> >> > enough?
>> >> 
>> >> Mmmh, I'm not sure I undestand, how can disassemble-native keep the
>> >> temporary file if this was deleted just after it was compiled and
>> >> loaded?
>> >
>> > By instructing the compilation not to delete it, and then deleting it
>> > after disassembly, I guess?
>> 
>> Okay but what if the file is never disassembled?  What if it's
>> disassembled more than once?  Isn't 3 simpler at this stage?
>
> I think we are mis-communicating.  What I meant is something like this:
>
>   . add a new optional argument to native-compile that would prevent
>     it from deleting the .eln file
>   . add a new function disassemble-native, which will call
>     native-compile with this new argument, perform disassembly, and
>     then delete the file

I see thanks for clarifying.

I'm not sure I like this option, reason is that I typically want to see
the disassembly of the already installed function rather than triggering
a new compilation.  Any change in the environment can lead to a
different output so I think is important to inspect what was produced
when it was commanded, no?

Bests

  Andrea